package cz.cvut.kbss.ear.eshop.service;

import cz.cvut.kbss.ear.eshop.environment.Generator;
import cz.cvut.kbss.ear.eshop.model.Product;
import org.junit.Test;
import org.springframework.beans.factory.annotation.Autowired;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

import static org.junit.Assert.*;

public class ProductServiceTest extends BaseServiceTestRunner {

    @PersistenceContext
    private EntityManager em;

    @Autowired
    private ProductService sut;

    @Test
    public void removeSetsRemovedStatusOnProduct() {
        final Product product = Generator.generateProduct();
        em.persist(product);
        assertFalse(product.isRemoved());
        sut.remove(product);

        final Product result = em.find(Product.class, product.getId());
        assertNotNull(result);
        assertTrue(product.isRemoved());
    }
}